%%%%% Please cite P. Turaga, A. Veeraraghavan, A. Srivastava, R. Chellappa,"Statistical Computations on Grassmann and Stiefel
%%%%% Manifolds for Image and Video-Based Recognition", IEEE PAMI Nov 2011, if you
%%%%% use these codes.

%%%%% This is a demo code for using the various Grassmann computation tools
%%%%% in the toolbox. No

clear all;
close all;



%%% we first generate several orthonormal matrices of size nxd, with d much
%%% smaller than n.

n = 1000; %%%% this is the dimension of the ambient space
d = 5;   %%%% this is the intrinsic dimension of the subspace


n_samples = 100;

samples = cell(1);

for i = 1:n_samples
    
    X = randn(n,d);
    [U,S,V] = svds(X,d);
    
    samples{i} = U;
end





%%%% Compute mean subspace

n_iter = 100; %%%% number of iterations to run Karcher mean computation algorithm
mu_grassmann = compute_grassmann_mean(samples,n_iter);


%%%% Perform k-means clustering

max_iter = 100; %%%% number of iterations to run K-means code
N_clusters = 5;
[labels,clust_centers,cost] = manifold_kmeans_grassmann(samples,N_clusters,max_iter);
hist(labels);
title('Histogram of cluster labels');
